'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _objectWithoutProperties = require('babel-runtime/helpers/object-without-properties')['default'];

var _Object$is = require('babel-runtime/core-js/object/is')['default'];

var _Object$assign = require('babel-runtime/core-js/object/assign')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _OptionJs = require('./Option.js');

var _OptionJs2 = _interopRequireDefault(_OptionJs);

var Select = (function (_React$Component) {
    _inherits(Select, _React$Component);

    function Select(props) {
        var _this = this;

        _classCallCheck(this, Select);

        _React$Component.call(this, props);
        this.loadData = [];
        this.focus = -1;
        this.state = {
            data: [],
            open: props.open,
            type: props.type,
            selected: [],
            selectedData: [],
            openSearch: this.props.openSearch
        };
        this.getSelected = function () {
            return _this.state.selectedData;
        };
        this.getDatas = function () {
            return _this.state.data;
        };
        this.isSelectAll = function () {
            return _this.state.data.length === _this.state.selectedData.length;
        };
        this.getSelectedValue = function () {
            var value = [];
            _this.state.selectedData.forEach(function (item) {
                return value.push(item.value);
            });
            return value;
        };
        this.getSelectedText = function () {
            var text = [];
            _this.state.selectedData.forEach(function (item) {
                return text.push(item.text);
            });
            return text;
        };
    }

    Select.prototype.componentWillMount = function componentWillMount() {
        var _this2 = this;

        var children = [],
            loadData = [],
            value = [],
            text = [],
            selected = [];
        this.loadData = [];
        if (this.props.children) {
            if (this.props.children instanceof Array) {
                this.props.children.map(function (item) {
                    if (item instanceof Array) {
                        children = children.concat(item);
                    } else {
                        children.push(item);
                    }
                });
            } else {
                children.push(this.props.children);
            }
            children.forEach(function (item, index) {
                var option = {
                    value: item.props.value,
                    text: item.props.children
                };

                _this2.loadData.push(option);

                // 优先selectAll -> 匹配value  , -> 匹配selected
                if (_this2.props.type === "multiple" && _this2.props.selectAll) {
                    text.push(item.props.children);
                    value.push(option);
                    selected.push(index);
                } else if (_this2.props.value !== undefined) {
                    (function () {
                        var values = _this2.props.value;
                        switch (typeof _this2.props.value) {
                            case 'string':
                                (function () {
                                    if (values === item.props.value) {
                                        text.push(item.props.children);
                                        value.push(option);
                                        selected.push(index);
                                    }
                                })();break;
                            case 'object':
                                (function () {
                                    if (values.length > 0) {
                                        values.map(function (val) {
                                            if (val === item.props.value) {
                                                text.push(item.props.children);
                                                value.push(option);
                                                selected.push(index);
                                            }
                                        });
                                    }
                                })();break;
                        }
                    })();
                } else if (_this2.props.selected !== undefined) {
                    (function () {
                        var selects = _this2.props.selected;
                        switch (typeof _this2.props.selected) {
                            case 'number':
                                (function () {
                                    if (index === selects) {
                                        text.push(item.props.children);
                                        value.push(option);
                                        selected.push(index);
                                    }
                                })();break;
                            case 'object':
                                (function () {
                                    if (selects.length > 0) {
                                        selects.map(function (select) {
                                            if (index === select) {
                                                text.push(item.props.children);
                                                value.push(option);
                                                selected.push(index);
                                            }
                                        });
                                    }
                                })();break;
                        }
                    })();
                } else {
                    // 默认选择第一项
                    if (_this2.props.type == "single" && _this2.props.selected == undefined) {
                        text = [_this2.loadData[0].text];
                        value = [_this2.loadData[0]];
                        selected = [0];
                    }
                }
            });
        }
        this.setState(_extends({}, this.state, {
            text: text,
            data: this.loadData,
            selected: selected,
            selectedData: value
        }));
    };

    Select.prototype.componentDidMount = function componentDidMount() {
        var _this3 = this;

        window.addEventListener('click', function (event) {
            _this3.globalMouseClick(event);
        });
        this.refs.myselect.getElementsByClassName('myselect-body-scroll').scrollTop = 0;
    };

    Select.prototype.componentWillUnmount = function componentWillUnmount() {
        window.removeEventListener('click', this.globalMouseClick);
    };

    Select.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
        // 属性的改变目前只能引起 数值上的变化。
        var bool_value = false,
            bool_selected = false;

        // value 相同的情况
        if (Array.isArray(this.props.value) && Array.isArray(nextProps.value)) {
            bool_value = _Object$is(this.props.value.sort().toString(), nextProps.value.sort().toString());
        } else {
            bool_value = _Object$is(this.props.value, nextProps.value);
        }

        // selected 相同的情况
        if (Array.isArray(this.props.selected) && Array.isArray(nextProps.selected)) {
            bool_selected = _Object$is(this.props.selected.sort().toString(), nextProps.selected.sort().toString());
        } else {
            bool_selected = _Object$is(this.props.selected, nextProps.selected);
        }

        if (bool_value && bool_selected) {
            return false;
        }

        var text = [],
            value = [],
            selected = [];
        this.loadData.forEach(function (option, index) {
            // 优先selectAll -> 匹配value  , -> 匹配selected
            if (nextProps.type === "multiple" && nextProps.selectAll) {
                text.push(option.text);
                value.push(option);
                selected.push(index);
            } else if (nextProps.value !== undefined) {
                (function () {
                    var values = nextProps.value;
                    switch (typeof nextProps.value) {
                        case 'string':
                            (function () {
                                if (values === option.value) {
                                    text.push(option.text);
                                    value.push(option);
                                    selected.push(index);
                                }
                            })();break;
                        case 'object':
                            (function () {
                                if (values.length > 0) {
                                    values.map(function (val) {
                                        if (val === option.value) {
                                            text.push(option.text);
                                            value.push(option);
                                            selected.push(index);
                                        }
                                    });
                                }
                            })();break;
                    }
                })();
            } else if (nextProps.selected !== undefined) {
                (function () {
                    var selects = nextProps.selected;
                    switch (typeof nextProps.selected) {
                        case 'number':
                            (function () {
                                if (index === selects) {
                                    text.push(option.text);
                                    value.push(option);
                                    selected.push(index);
                                }
                            })();break;
                        case 'object':
                            (function () {
                                if (selects.length > 0) {
                                    selects.map(function (select) {
                                        if (index === select) {
                                            text.push(option.text);
                                            value.push(option);
                                            selected.push(index);
                                        }
                                    });
                                }
                            })();break;
                    }
                })();
            }
        });

        this.setState(_extends({}, this.state, {
            text: text,
            selected: selected,
            selectedData: value
        }));
    };

    Select.prototype._generateHead = function _generateHead() {
        var _this4 = this;

        var text = this.state.text;

        var searchInput = function searchInput() {
            return _react2['default'].createElement('input', { type: 'text', className: 'search-input', value: text, title: text, onClick: _this4.onHandClick.bind(_this4), onChange: _this4.onHandChange.bind(_this4) });
        };

        var innerText = function innerText() {
            switch (_this4.props.type) {
                case 'single':
                    return (function () {
                        return searchInput();
                    })();
                case 'multiple':
                    return (function () {
                        if (_this4.props.openSearch) {
                            var showText = undefined;
                            if (_this4.state.text.length > 0 && _this4.props.showMultipleSize > -1 && _this4.state.text.length > _this4.props.showMultipleSize) {
                                showText = _this4.state.selectedData.length + " " + _this4.props.outSelectSizeText;
                            } else {
                                showText = text;
                            }
                            return _react2['default'].createElement('input', { type: 'text', className: 'search-input', value: showText, title: showText, onClick: _this4.onHandClick.bind(_this4), onChange: _this4.onHandChange.bind(_this4) });
                        } else {
                            return text && text instanceof Array ? text.map(function (item, index) {
                                return _react2['default'].createElement(
                                    'div',
                                    { key: index, className: 'multipleItem' },
                                    _react2['default'].createElement(
                                        'span',
                                        { className: 'Select-value-icon', onClick: _this4.removeItem.bind(_this4, index) },
                                        '×'
                                    ),
                                    _react2['default'].createElement(
                                        'span',
                                        { className: 'Select-value-label', onClick: _this4.onHandClick.bind(_this4), title: item },
                                        item
                                    )
                                );
                            }) : _react2['default'].createElement(
                                'span',
                                null,
                                text
                            );
                        }
                    })();
            }
        };

        return _react2['default'].createElement(
            'div',
            { onClick: function () {
                    return _this4.toggleMenu();
                } },
            _react2['default'].createElement(
                'div',
                { className: 'myselect-head' },
                _react2['default'].createElement(
                    'div',
                    { className: 'items', ref: 'multipleItem' },
                    innerText()
                ),
                _react2['default'].createElement(
                    'div',
                    { className: 'dropdown-toggle' },
                    _react2['default'].createElement('i', null)
                )
            )
        );
    };

    Select.prototype.contains = function contains(array, item) {
        var bool = false;
        array.forEach(function (arr) {
            if (arr.value == item.value) return bool = true;
        });
        return bool;
    };

    Select.prototype._generateBody = function _generateBody() {
        var _this5 = this;

        var _renderBody = function _renderBody() {
            var unselectData = [],
                selected = [],
                text = [],
                newDatas = [];
            // 当为复选框，且开启搜索的时候
            if (_this5.props.type === "multiple" && _this5.props.openSearch) {
                (function () {
                    var datas = [].concat(_this5.state.data);
                    var selects = [];

                    _this5.state.selectedData.forEach(function (item, index) {
                        if (_this5.contains(_this5.state.data, item)) {
                            selects.push(item);
                        }
                    });

                    selects.forEach(function (item, index) {
                        newDatas.push(item);
                        selected.push(index);
                        text.push(item.text);
                        datas = datas.filter(function (data) {
                            return item.value !== data.value;
                        });
                    });

                    unselectData = datas;

                    unselectData.forEach(function (item) {
                        return newDatas.push(item);
                    });

                    _this5.state.data = newDatas;
                    _this5.state.text = text;
                    _this5.state.selected = selected;
                })();
            }
            return _this5.state.data.map(function (item, i) {
                var selected = false,
                    focused = false;

                _this5.focus == i ? focused = true : '';

                typeof _this5.state.selected == 'object' ? _this5.state.selected.map(function (item) {
                    return item == i ? selected = true : '';
                }) : '';

                return unselectData.length > 0 && _this5.state.selected.length != 0 && i == _this5.state.selected.length ? _react2['default'].createElement(
                    'div',
                    { key: i },
                    _react2['default'].createElement('hr', null),
                    _react2['default'].createElement(_OptionJs2['default'], {
                        item: item,
                        selected: selected,
                        index: i,
                        focused: focused,
                        hasIcon: _this5.props.hasIcon,
                        type: _this5.state.type,
                        selectItem: _this5.selectItem.bind(_this5),
                        focusItem: _this5.focusItem.bind(_this5)
                    })
                ) : _react2['default'].createElement(
                    'div',
                    { key: i },
                    _react2['default'].createElement(_OptionJs2['default'], {
                        item: item,
                        selected: selected,
                        index: i,
                        focused: focused,
                        hasIcon: _this5.props.hasIcon,
                        type: _this5.state.type,
                        selectItem: _this5.selectItem.bind(_this5),
                        focusItem: _this5.focusItem.bind(_this5)
                    })
                );
            });
        };

        return _react2['default'].createElement(
            'div',
            null,
            _react2['default'].createElement(
                'div',
                { className: 'myselect-body', style: { maxHeight: this.props.maxHeight }, ref: 'myselectBody' },
                _react2['default'].createElement(
                    'div',
                    { className: 'myselect-body-scroll' },
                    this.props.type == "multiple" && this.props.showMultipleBar && this.state.data.length > 0 ? _react2['default'].createElement(
                        'div',
                        { className: 'myselect-opration' },
                        _react2['default'].createElement(
                            'a',
                            { href: 'javascript:;', onClick: this.selectAll.bind(this) },
                            '全选'
                        ),
                        '/',
                        _react2['default'].createElement(
                            'a',
                            { href: 'javascript:;', onClick: this.unSelectAll.bind(this) },
                            '全不选'
                        )
                    ) : null,
                    this.state.data.length > 0 ? _renderBody() : _react2['default'].createElement(
                        'div',
                        { className: 'no-data' },
                        _react2['default'].createElement(
                            'div',
                            { className: 'text' },
                            this.props.noSearchDataTips
                        )
                    )
                )
            )
        );
    };

    Select.prototype.onHandChange = function onHandChange(e) {
        e.stopPropagation();
        if (this.props.openSearch) {
            this.filterBySearch();
        }
    };

    Select.prototype.onHandClick = function onHandClick(e) {
        var _this6 = this;

        e.stopPropagation();

        // 组织冒泡导致不可关闭
        _reactDom2['default'].findDOMNode(this.refs.myselectBody).click();

        var selects = [];var _state = this.state;
        var open = _state.open;
        var selected = _state.selected;
        var text = _state.text;
        var data = _state.data;

        if (this.state.selectedData && this.state.selectedData.length > 0) {
            // 序列重置
            this.loadData.map(function (item, index) {
                _this6.state.selectedData.forEach(function (select) {
                    if (select.value === item.value) {
                        selects.push(index);
                    }
                });
            });
        }

        if (!this.state.open) {
            if (!this.props.openSearch) {
                open = true;
                data = this.loadData;
                selected = selects;
            } else {
                open = true;
                text = [];
                data = this.loadData;
                selected = selects;
            }
        } else {
            if (this.props.openSearch && this.props.type === "multiple") {
                open = true;
                text = [];
                data = this.loadData;
                selected = selects;
            }
        }

        this.setState(_extends({}, this.state, {
            open: open,
            text: text,
            selected: selected,
            data: data
        }));
    };

    Select.prototype.focusItem = function focusItem(focus) {
        this.focus = focus;
    };

    Select.prototype.filterBySearch = function filterBySearch() {
        var _this7 = this;

        var filter = this.refs.myselect.getElementsByClassName('search-input')[0].value;

        var data = [],
            selected = [];

        this.loadData.forEach(function (item, index) {
            if (item.text.toString().toLowerCase().indexOf(filter.toLowerCase()) > -1) {
                data.push(item);
            }
        });

        // 重新匹配是否有选中
        switch (this.props.type) {
            case 'single':
                (function () {
                    data.map(function (item, index) {
                        if (_this7.state.selectedData && _this7.state.selectedData.length > 0) {
                            if (_this7.state.selectedData[0].value === item.value) {
                                selected.push(index);
                            }
                        }
                    });
                })();break;
            case 'multiple':
                (function (item, index) {
                    data.map(function (item, index) {
                        if (_this7.state.selectedData && _this7.state.selectedData.length > 0) {
                            // 序列重置
                            _this7.state.selectedData.forEach(function (select) {
                                if (select.value === item.value) {
                                    selected.push(index);
                                }
                            });
                        }
                    });
                })();break;
        }

        this.setState(_extends({}, this.state, {
            text: [filter],
            data: data,
            selected: selected
        }));
    };

    Select.prototype.toggleMenu = function toggleMenu() {
        this.setState(_extends({}, this.state, {
            open: !this.state.open
        }));
    };

    Select.prototype.hasItemIndex = function hasItemIndex(item) {
        var index = -1;
        this.state.selectedData.forEach(function (select, i) {
            if (select.value == item.value) {
                index = i;
            }
        });
        return index;
    };

    Select.prototype.selectItem = function selectItem(item) {
        var _this8 = this;

        if (item) {
            switch (this.state.type) {
                case 'single':
                    (function () {
                        _this8.setState({
                            text: item.text,
                            selected: [_this8.focus],
                            selectedData: [item]
                        }, function () {
                            _this8.toggleMenu();
                            _this8.props.onSelected ? _this8.props.onSelected(item) : '';
                        });
                    })();break;
                case 'multiple':
                    (function () {
                        var _state2 = _this8.state;
                        var selectedData = _state2.selectedData;
                        var data = _state2.data;

                        var itemIndex = _this8.hasItemIndex(item);
                        var text = [],
                            selected = [];
                        // 如果已经被选中
                        if (itemIndex > -1) {
                            selectedData.splice(itemIndex, 1);
                        } else {
                            selectedData.push(item);
                        }
                        // 重新遍历data
                        _this8.loadData.forEach(function (option, index) {
                            selectedData.forEach(function (select) {
                                if (option.value == select.value) {
                                    text.push(select.text);
                                }
                            });
                        });
                        data.forEach(function (option, index) {
                            selectedData.forEach(function (select) {
                                if (option.value == select.value) {
                                    selected.push(index);
                                }
                            });
                        });
                        _this8.setState(_extends({}, _this8.state, {
                            text: text,
                            selected: selected,
                            selectedData: selectedData
                        }), function () {
                            _this8.props.onSelected ? _this8.props.onSelected(selectedData) : '';
                        });
                    })();break;
            }
        }
    };

    Select.prototype.removeItem = function removeItem(index, e) {
        var _this9 = this;

        e.stopPropagation();
        var texts = this.state.text;
        var selected = this.state.selected;
        var selectedData = this.state.selectedData;

        if (index || index == 0) {
            texts.splice(index, 1);
            selected.splice(index, 1);
            selectedData.splice(index, 1);
        }
        this.setState(_extends({}, this.state, {
            text: texts,
            selected: selected,
            selectedData: selectedData
        }), function () {
            _this9.props.onSelected ? _this9.props.onSelected(selectedData) : '';
        });
    };

    Select.prototype.globalMouseClick = function globalMouseClick(event) {
        var _this10 = this;

        if (this.refs.myselect) {
            var target = event.target;
            var i = 0;
            var hideMenu = true;
            while (this.checkParentElement(target) && i < 10) {
                target = target.parentElement;
                i++;
                if (this.refs.myselect && target && target.innerHTML == this.refs.myselect.innerHTML) {
                    hideMenu = false;
                }
            }
            if (hideMenu && target.className != 'myselect-item' && target.className != 'myselect-item selected') {
                var _state3 = this.state;
                var text = _state3.text;
                var data = _state3.data;
                var selected = _state3.selected;
                var _open = _state3.open;

                if (this.props.openSearch) {
                    (function () {
                        var selects = [],
                            texts = [];

                        switch (_this10.props.type) {
                            case 'single':
                                (function () {
                                    if (_this10.state.selectedData && _this10.state.selectedData.length > 0) {
                                        texts.push(_this10.state.selectedData[0].text);
                                        // 序列重置
                                        _this10.loadData.map(function (item, index) {
                                            if (_this10.state.selectedData[0].value === item.value) selects.push(index);
                                        });

                                        text = texts;
                                        data = _this10.loadData;
                                        selected = selects;
                                    }
                                })();break;
                            case 'multiple':
                                (function () {
                                    if (_this10.state.selectedData && _this10.state.selectedData.length > 0) {
                                        // 序列重置
                                        _this10.loadData.map(function (item, index) {
                                            _this10.state.selectedData.forEach(function (select) {
                                                if (select.value === item.value) {
                                                    selects.push(index);
                                                    texts.push(select.text);
                                                }
                                            });
                                        });

                                        text = texts;
                                        data = _this10.loadData;
                                        selected = selects;
                                    }
                                })();break;
                        }
                    })();
                }
                this.setState(_extends({}, this.state, {
                    open: false,
                    text: text,
                    data: data,
                    selected: selected
                }));
            }
        }
    };

    Select.prototype.checkParentElement = function checkParentElement(target) {
        return target.parentElement != null;
    };

    Select.prototype.selectAll = function selectAll(e) {
        e.stopPropagation();
        var data = [].concat(this.state.data);
        var text = [],
            selected = [];

        if (data.length > 0) {
            data.forEach(function (item, index) {
                text.push(item.text);
                selected.push(index);
            });
        }
        this.setState(_extends({}, this.state, {
            text: text,
            selected: selected,
            selectedData: data
        }));
    };

    Select.prototype.unSelectAll = function unSelectAll(e) {
        e.stopPropagation();
        this.setState(_extends({}, this.state, {
            text: [],
            selected: [],
            selectedData: []
        }));
    };

    Select.prototype.render = function render() {
        var _props = this.props;
        var style = _props.style;
        var width = _props.width;

        var otherProps = _objectWithoutProperties(_props, ['style', 'width']);

        if (width) {
            if (style && style.width) {
                style.width = width;
            } else {
                style = _Object$assign({}, { width: width });
            }
        }
        return _react2['default'].createElement(
            'div',
            _extends({}, otherProps, { style: style, ref: 'myselect', className: this.props.className ? "myselect " + this.props.className : "myselect" }),
            this._generateHead(),
            _react2['default'].createElement(
                'div',
                { style: this.state.open && !this.props.disabled ? {} : { display: 'none' } },
                this._generateBody()
            )
        );
    };

    return Select;
})(_react2['default'].Component);

Select.propTypes = {
    /**
     * 最大高度，超过出现滚动条
     * {number}
     */
    maxHeight: _react2['default'].PropTypes.number,
    /**
     * 宽度
     * {number|string}
     */
    width: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.string, _react2['default'].PropTypes.number]),
    /**
     * 是否开启搜索
     * {boolean}
     */
    openSearch: _react2['default'].PropTypes.bool,
    /**
     * select 类型 ， single -> 单选(默认)，multiple -> 复选
     * {[type]}
     */
    type: _react2['default'].PropTypes.oneOf(["single", "multiple"]),
    /**
     * onSelect 选中事件
     */
    onSelected: _react2['default'].PropTypes.func,
    /**
     * 设置选中序列号
     * {number | array}
     */
    selected: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.array, _react2['default'].PropTypes.number]),
    /**
     * 设置所选中的值
     * {string | array}
     */
    value: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.array, _react2['default'].PropTypes.string]),
    /**
     * @private
     * 禁用
     */
    disabled: _react2['default'].PropTypes.bool,
    /**
     * 是否显示图标
     * {Boolean}
     */
    hasIcon: _react2['default'].PropTypes.bool,
    /**
     * 是否打开
     * {Boolean}
     */
    open: _react2['default'].PropTypes.bool,
    /**
     * 是否选中全部
     * {boolean}
     */
    selectAll: _react2['default'].PropTypes.bool,
    /**
     * 搜索开启，无查找内容提示语
     * {string}
     */
    noSearchDataTips: _react2['default'].PropTypes.string,
    /**
     * 复选显示在输入框size
     * {number}
     */
    showMultipleSize: _react2['default'].PropTypes.number,
    /**
     * 复选选项超出size,显示的文本
     * {string}
     */
    outSelectSizeText: _react2['default'].PropTypes.string,
    /**
     * 复选情况下是否显示 全选/全不选 
     * @type {boolean}
     */
    showMultipleBar: _react2['default'].PropTypes.bool
};

Select.defaultProps = {
    open: false,
    noSearchDataTips: '没有找到相关数据',
    hasIcon: false,
    selectAll: false,
    type: "single",
    showMultipleSize: -1, // 不限
    maxHeight: 180,
    openSearch: false,
    showMultipleBar: true,
    outSelectSizeText: 'selected...'
};

exports['default'] = Select;
module.exports = exports['default'];